#################################################
# Effettua l'elevamento a potenza di due valori #
# inseriti a tempo di assemblaggio, tramite lo  #
# utilizzo delle sole operazioni elementari     #
# di addizione unitaria e test di uguaglianza,  #
# della funzione di somma dell'ex 019 e della   #
# funzione di prodotto dell'ex 020!             #
#################################################





.text
	lw $a0, A
	lw $a1, B
	li $a2, 1

	jal esponenziale
	
	move $a0, $v0
	li $v0, 1
	syscall
	
	li $v0, 10
	syscall



###################
# INIZIO FUNZIONE #
###################
esponenziale:
	bne $a1, $zero, elseif_e
		li $v0, 1
		jr $ra
	elseif_e: bne $a2, $a1, else_e
		move $v0, $a0
		jr $ra
	else_e:
		subu $sp, $sp, 16
		sw $a0, 12($sp)
		sw $a1,  8($sp)
		sw $a2,  4($sp)
		sw $ra,   ($sp)
		
		addi $a2, $a2, 1
		
		jal esponenziale

		move $a1, $a0		# sposto m		
		move $a0, $v0		# prendo il risultato della chiamata
		li $a2, 1		# inizializzo l'indice i a 0
		
		jal prodotto
		
		lw $ra,   ($sp)
		lw $a2,  4($sp)
		lw $a1,  8($sp)
		lw $a0, 12($sp)
		addu $sp, $sp, 16
		
		jr $ra
	endif_e:
#################
# FINE FUNZIONE #
#################		





###################
# INIZIO FUNZIONE #
###################
prodotto:
	bne $a2, $a1, else_p
		move $v0, $a0
		jr $ra
	else_p:
		subu $sp, $sp, 16
		sw $a0, 12($sp)
		sw $a1,  8($sp)
		sw $a2,  4($sp)
		sw $ra,   ($sp)
		
		addi $a2, $a2, 1
		
		jal prodotto

		move $a1, $a0		# sposto m		
		move $a0, $v0		# prendo il risultato della chiamata
		li $a2, 0		# inizializzo l'indice i a 0
		
		jal somma
		
		lw $ra,   ($sp)
		lw $a2,  4($sp)
		lw $a1,  8($sp)
		lw $a0, 12($sp)
		addu $sp, $sp, 16
		
		jr $ra
	endif_p:
#################
# FINE FUNZIONE #
#################


###################
# INIZIO FUNZIONE #
###################
somma:
	bne $a2, $a1, endif_s		# caso base (i == n):
		move $v0, $a0		# torno il valore di m
		jr $ra			# al chiamante
	endif_s:

# passo induttivo: aumento m e i di 1 e proseguo
	subu $sp, $sp, 12
	sw $a0, 8($sp)			# è necessario salvare questi
	sw $a2, 4($sp)			# valori in questo caso,
	sw $ra,  ($sp)			# o si tratta di puro formalismo?

	addi $a0, $a0, 1
	addi $a2, $a2, 1
	
	jal somma
	
	lw $ra,  ($sp)
	lw $a2, 4($sp)
	lw $a0, 8($sp)
	addu $sp, $sp, 12
	
	jr $ra
#################
# FINE FUNZIONE #
#################


.data
	A:	.word 2
	B:	.word 10
