##################################################
# Calcola il fattoriale di un valore caricato    #
# a tempo di assemblaggio, utilizzando solo      #
# le operazioni di somma unitaria e test di      #
# uguaglianza, e la funzione prodotto dell'ex 20 #
##################################################




.text
	lw $a0, A

	jal fattoriale
	
	move $a0, $v0
	li $v0, 1
	syscall
	
	li $v0, 10
	syscall
	



###################
# INIZIO FUNZIONE #
###################
fattoriale:
	beq $a0, $zero, exec_f
	beq $a0, 1, exec_f
	j else_f
	
	exec_f:
		li $v0, 1
		jr $ra
	else_f:
		subu $sp, $sp, 8
		sw $a0, 4($sp)
		sw $ra,  ($sp)
		
		subi $a0, $a0, 1
		
		jal fattoriale

		lw $ra,  ($sp)
		lw $a0, 4($sp)
		addu $sp, $sp, 8

		subu $sp, $sp, 8
		sw $a0, 4($sp)
		sw $ra,  ($sp)

		move $a1, $a0		# sposto m
		move $a0, $v0		# passo il risultato della chiamata
		li $a2, 1		# inizializzo l'indice i a 0
		
		jal prodotto

		lw $ra,  ($sp)
		lw $a0, 4($sp)
		addu $sp, $sp, 8

		jr $ra
	endif_f:
#################
# FINE FUNZIONE #
#################	





###################
# INIZIO FUNZIONE #
###################
prodotto:
	bne $a2, $a1, else_p
		move $v0, $a0
		jr $ra
	else_p:
		subu $sp, $sp, 16
		sw $a0, 12($sp)
		sw $a1,  8($sp)
		sw $a2,  4($sp)
		sw $ra,   ($sp)
		
		addi $a2, $a2, 1
		
		jal prodotto

		move $a1, $a0		# sposto m		
		move $a0, $v0		# prendo il risultato della chiamata
		li $a2, 0		# inizializzo l'indice i a 1
		
		jal somma
		
		lw $ra,   ($sp)
		lw $a2,  4($sp)
		lw $a1,  8($sp)
		lw $a0, 12($sp)
		addu $sp, $sp, 16
		
		jr $ra
	endif_p:
#################
# FINE FUNZIONE #
#################


###################
# INIZIO FUNZIONE #
###################
somma:
	bne $a2, $a1, endif_s		# caso base (i == n):
		move $v0, $a0		# torno il valore di m
		jr $ra			# al chiamante
	endif_s:

# passo induttivo: aumento m e i di 1 e proseguo
	subu $sp, $sp, 12
	sw $a0, 8($sp)			# è necessario salvare questi
	sw $a2, 4($sp)			# valori in questo caso,
	sw $ra,  ($sp)			# o si tratta di puro formalismo?

	addi $a0, $a0, 1
	addi $a2, $a2, 1
	
	jal somma
	
	lw $ra,  ($sp)
	lw $a2, 4($sp)
	lw $a0, 8($sp)
	addu $sp, $sp, 12
	
	jr $ra
#################
# FINE FUNZIONE #
#################

	
.data
	A:	.word 7
