##############################################
# Controlla se una stringa caricata a tempo  #
# di assemblaggio è o meno palindroma,       #
# utilizzando una funzione ricorsiva         #
##############################################


.text
	la $a0, stringa
	li $a1, 0
	jal strlen
	
	la $a0, stringa
	li $a1, 0
	move $a2, $v0
	sub $a2, $a2, 1
	
	jal palindroma
	
	bne $v0, 1, else
		li $v0, 4
		la $a0, avviso_ok
		syscall

		j endif
	else:
		li $v0, 4
		la $a0, avviso_no
		syscall
	endif:

	li $v0, 10
	syscall

###################
# INIZIO FUNZIONE #
###################
palindroma:
	blt $a1, $a2, else_p1
		li $v0, 1
		jr $ra
	else_p1:
		add $t0, $a0, $a1
		lbu $s0, ($t0)
		add $t0, $a0, $a2
		lbu $s1, ($t0)
		
		bne $s0, $s1, else_p2		# i due caratteri sono uguali
			subu $sp, $sp, 4
			sw $ra, ($sp)
			
			addi $a1, $a1, 1
			subi $a2, $a2, 1
			
			jal palindroma
			
			lw $ra, ($sp)
			addu $sp, $sp, 4
			
			j endif_p2
		else_p2:			# i due caratteri sono diversi
			li $v0, 0
			jr $ra
		endif_p2:
	endif_p1:
	
	jr $ra
#################
# FINE FUNZIONE #
#################


###################
# INIZIO FUNZIONE #
###################
strlen:
	li $v0, 0			# contatore di caratteri
	lbu $t1, ($a0)			# carico il primo carattere
	
	for: beqz $t1, end_for
		addi $v0, $v0, 1
		
		addi $a0, $a0, 1	# devo avanzare di un solo byte!
		lbu $t1, ($a0)		# carico prossimo carattere (byte)
		
		j for
	end_for:

	jr $ra				# ritorno al main da dove l'avevo lasciato
#################
# FINE FUNZIONE #
#################


.data
	stringa:	.asciiz "abcedcba"
	avviso_ok:	.asciiz "Stringa palindroma\n"
	avviso_no:	.asciiz "Stringa NON palindroma\n"
